# Pull Request

By using `Pull Request` you can let original project's members know your code's changes for code review. Also, the alterations can be discussed with the members and your codes can be merged when code review is complete.

`Pull Request`, however, is only available for projects using git repository.

## Before you begin

Before you begin, you must do the following:

1. Create an account for Yobi.
1. Fork any project.
1. Push codes modified to project forked. (If there are no modifications to your source codes, you cannot use `Pull Request`)

## Sending codes

`Pull Request` allows original project's members know your code's alterations which can be reviewed.

1. Go to forked project
1. Click `Pull Request` <그림 삽입>
1. Once screen is changed, click `New Pull Request` button. <그림 삽입>

Or

1. Click `Pull Request` on original project.
1. Click `New Pull Request` button. <그림 삽입>

Choose branches of source and destination, fill forms and click `Save` button.

<그림 삽입>

### Conflicts

If codes modified come into conflicts with original ones, you will see below. To solve conflicts, follow this.

<그림 삽입>

Although these conflicts are not solved, `Pull Request` can be used. But you have to solve it before you click `Accept` button.

## Code Review

Original project's members can review codes. If project's share option is public, non project's members can do it. They are able to let others give feedback and discuss with others.

1. Go to a pull request you want to review.
1. Click `Code Review` tab.
1. Select where you want to review. There are two ways.
    * Drag codes you want to review and click comment button.
    * Click comment button at the left of line you want to review.
1. Write your review and click `Add Comment` button.

<그림 삽입>

Also, you can comment without selecting codes.

1. Go to a pull request you want to review.
1. Click `Code Review` tab.
1. Move to bottom of page then you will see comment box.
1. Write your review and click `Add Comment` button.

<그림 삽입>

## Accept

Using `Accept`, you can merge source codes reviewed to original project's repository.

1. Click a request within `Pull Request` menu.
1. Click `Accept`.

<그림 삽입>

### Conflicts

See `Pull Request` > `Conflicts`
